/**
* @file Douglas Crockford's monad library as UMD/ES6 module
* @version 1.0.6
* Based on Douglas Crockford's Public Domain monad.js library.
* This is an almost verbatim copy of Douglas Crockford's work, but
* made easy for use in browser/node.js, or as an ES6 module.
*
* As github does not provide a Public Domain option as one of the
* supported licenses, this work uses the liberal MIT license instead.
* @copyright (c) 2017 Greg Borota.
* @license MIT
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*/
!function(e,n){"object"==typeof exports&&"undefined"!=typeof module?n(exports):"function"==typeof define&&define.amd?define(["exports"],n):n(e.monadJs={})}(this,function(e){"use strict";function n(e){function n(n){var r=Object.create(t);return r.bind=function(e,t){return e.apply(void 0,[n].concat(t))},"function"==typeof e&&(n=e(r,n)),r}var t=Object.create(null);return t.isMonad=!0,n.method=function(e,r){return t[e]=r,n},n.liftValue=function(e,r){return t[e]=function(){for(var e=[],n=arguments.length;n--;)e[n]=arguments[n];return this.bind(r,e)},n},n.lift=function(e,r){return t[e]=function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];var o=this.bind(r,e);return o&&!0===o.isMonad?o:n(o)},n},n}var t=n(),r=n(function(e,n){return null===n||void 0===n?(e.isNull=!0,e.bind=function(){return e},null):(e.isNull=!1,n)}),o=function(){function e(e,n){e.forEach(function(e){setImmediate(e,n)})}return{make:function n(){function t(e,n,t){var r="keep"===e?u:i;r[r.length]="function"!=typeof n?t[e]:function(e){try{var r=n(e);r&&!0===r.isPromise?r.when(t.keep,t.break):t.keep(r)}catch(e){t.break(e)}}}function r(n,t,r){if("pending"!==f)throw new Error("overpromise");f=n,e(r,o=t),u.length=0,i.length=0}var o,i=[],u=[],f="pending";return{break:function(e){r("broken",e,i)},keep:function(e){r("kept",e,u)},promise:{isPromise:!0,when:function(r,a){var c=n();switch(f){case"pending":t("keep",r,c),t("break",a,c);break;case"kept":t("keep",r,c),e(u,o);break;default:break;case"broken":t("break",a,c),e(i,o)}return c.promise}}}},every:function(e){var n=e.length,t=[],r=o.make();return n?e.forEach(function(e,o){e.when(function(e){t[o]=e,0===(n-=1)&&r.keep(t)},function(e){n=NaN,r.break(e)})}):r.break(e),r.promise},first:function(e){function n(){0!==(r-=1)||t||i.break()}var t=!1,r=e.length,i=o.make();return 0===r?i.break(e):e.forEach(function(e){e.when(function(e){t||(t=!0,i.keep(e)),n()},n)}),i.promise},any:function(e){function n(){0===(t-=1)&&i.keep(r)}var t=e.length,r=[],i=o.make();return t?e.forEach(function(e,t){e.when(function(e){r[t]=e,n()},n)}):i.keep(r),i.promise},kept:function(e){var n=o.make();return n.keep(e),n.promise},broken:function(e){var n=o.make();return n.break(e),n.promise}}}();e.makeMonad=n,e.identity=t,e.maybe=r,e.vow=o,Object.defineProperty(e,"__esModule",{value:!0})});
